import { Ref } from 'vue';
import { CommonProps } from '@/common/types/props';
export interface Props extends CommonProps {
    modelValue: string | number;
    modelValueEventName?: string;
    type?: 'text' | 'number' | 'password' | 'email' | 'tel' | 'url' | 'search';
    placeholder?: string;
    mask?: RegExp;
    invalid?: boolean;
    integer?: boolean;
    min?: number;
    max?: number;
    step?: number;
    focusOnMount?: boolean;
}
export interface InputExpose {
    input: HTMLInputElement | null;
    forceFocus: () => void;
}
declare const _default: import("vue").DefineComponent<__VLS_WithDefaults<__VLS_TypePropsToRuntimeProps<Props>, {
    modelValueEventName: string;
    type: string;
    invalid: boolean;
    integer: boolean;
    step: number;
}>, {
    input: Ref<HTMLInputElement | null>;
    forceFocus: () => void;
}, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
    mount: () => void;
    unmount: () => void;
    "update:modelValue": (value: string | number) => void;
    "model-value-updated": (value: string | number) => void;
    focusin: () => void;
    focusout: () => void;
    keydown: (event: KeyboardEvent) => void;
    input: (value: string | number) => void;
}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<__VLS_WithDefaults<__VLS_TypePropsToRuntimeProps<Props>, {
    modelValueEventName: string;
    type: string;
    invalid: boolean;
    integer: boolean;
    step: number;
}>>> & {
    onFocusin?: (() => any) | undefined;
    onFocusout?: (() => any) | undefined;
    onInput?: ((value: string | number) => any) | undefined;
    onKeydown?: ((event: KeyboardEvent) => any) | undefined;
    onMount?: (() => any) | undefined;
    onUnmount?: (() => any) | undefined;
    "onModel-value-updated"?: ((value: string | number) => any) | undefined;
    "onUpdate:modelValue"?: ((value: string | number) => any) | undefined;
}, {
    type: "number" | "text" | "search" | "password" | "email" | "tel" | "url";
    modelValueEventName: string;
    invalid: boolean;
    integer: boolean;
    step: number;
}, {}>;
export default _default;
type __VLS_NonUndefinedable<T> = T extends undefined ? never : T;
type __VLS_TypePropsToRuntimeProps<T> = {
    [K in keyof T]-?: {} extends Pick<T, K> ? {
        type: import('vue').PropType<__VLS_NonUndefinedable<T[K]>>;
    } : {
        type: import('vue').PropType<T[K]>;
        required: true;
    };
};
type __VLS_WithDefaults<P, D> = {
    [K in keyof Pick<P, keyof P>]: K extends keyof D ? __VLS_Prettify<P[K] & {
        default: D[K];
    }> : P[K];
};
type __VLS_Prettify<T> = {
    [K in keyof T]: T[K];
} & {};
